<?php

/* *** <head></head> 안에 본문에 넣을 단추의 CSS를 끼워넣는다. *** */
function head_stylesheet($target) {

	global $configVal;
	$data = Setting::fetchConfigVal($configVal);
	if(is_null($data)) init_config($data);

	$content = "<style type=\"text/css\">";
	$position_array = array("onTop", "onBottom");
	foreach($position_array as $position) 
		if($data[$position]) $content .= stylesheet($position);
	$content .= "</style>".CRLF;

	return $target.CRLF.$content.CRLF;
}

/* *** 위치에 맞추어 단추의 CSS 내용을 돌려 준다. *** */
function stylesheet($position) {

	global $pluginURL, $configVal;
	$data = Setting::fetchConfigVal($configVal);
	
	if(is_null($data)) init_config($data);

	$type = $data[$position.'_type'];		// 단추 모양
	$align = $data[$position.'_align'];		// 가로 정렬
	
	if($data[$position.'_type'] == "text") $icon_type = "button"; else $icon_type = "div";

	if(strpos($_SERVER['HTTP_USER_AGENT'], "MSIE")) {
		preg_match("/MSIE (?P<version>\d+)/", $_SERVER['HTTP_USER_AGENT'], $browser);
		if($browser['version'] < 8) $icon_type = "button";
	}
			
	preg_match("/(?P<size>\w+)($|\((?P<unit>(\d+))\))/", $data[$position.'_margin_top'], $margin_top);		// 여백의 크기와 단위를 뽑는다.
	preg_match("/(?P<size>\w+)($|\((?P<unit>(\d+))\))/", $data[$position.'_margin_bottom'], $margin_bottom);
	preg_match("/(?P<size>\w+)($|\((?P<unit>(\d+))\))/", $data[$position.'_margin_left'], $margin_left);
	preg_match("/(?P<size>\w+)($|\((?P<unit>(\d+))\))/", $data[$position.'_margin_right'], $margin_right);
	preg_match("/(?P<size>\w+)($|\((?P<unit>(\d+))\))/", $data[$position.'_icon_interval'], $icon_interval);
	
	if(empty($margin_top['unit'])) $margin_top['unit'] = "px";
	if(empty($margin_bottom['unit'])) $margin_bottom['unit'] = "px";
	if(empty($margin_left['unit'])) $margin_left['unit'] = "px";
	if(empty($margin_right['unit'])) $margin_right['unit'] = "px";
	if(empty($icon_interval['unit'])) $icon_interval['unit'] = "px";
	
	if(empty($margin_top['size'])) $margin_top['size'] = "0";
	if(empty($margin_bottom['size'])) $imargin_bottom['size'] = "0";
	if(empty($margin_left['size'])) $margin_left['size'] = "0";
	if(empty($margin_right['size'])) $margin_right['size'] = "0";
	if(empty($icon_interval['size'])) $icon_interval['unit'] = "0";

	if($align=="left") {$icon_margin_right = $icon_interval['size']; $icon_margin_left = 0;}		// 가로 정렬 방식에 맞게 단추 간격을 정한다.
	else if($align=="right") { $icon_margin_left = $icon_interval['size']; $icon_margin_right = 0;}
	else {
		$icon_margin_left = (int)($icon_interval['size']/2);
		$icon_margin_right = (int)($icon_interval['size']/2) + $icon_interval['size']%2;
	}
	
	$content .= "#sns_icons_".$position." {";
	if($align) $content .= "text-align:".$align.";";
	$content .= "margin:".$margin_top['size'].$margin_top['unit']." ".$margin_right['size'].$margin_right['unit']." ".$margin_bottom['size'].$margin_bottom['unit']." ".$margin_left['size'].$margin_left['unit'].";";
	$content .= "}";

	preg_match("/(?P<width>\d+)x(?P<height>\d+)/", $type, $icon_size);

	$content .= "#sns_icons_".$position." div.icon_wrap {";
	$content .= "cursor: pointer;";
	$content .= "display: inline;";
	$content .= "height:".$icon_size['height']."px;";

	if($icon_margin_left) $content .= "margin-left:".$icon_margin_left.$icon_interval['unit'].";";
	if($icon_margin_right) $content .= "margin-right:".$icon_margin_right.$icon_interval['unit'].";";
	$content .= "}";
	
	if($type != "text") {
		$content .= "#sns_icons_".$position." div.icon_wrap ".$icon_type." {";
		$content .= "border:0;";
		$content .= "display: inline-block;";
		$content .= "width:".$icon_size['width']."px;";
		$content .= "height:".$icon_size['height']."px;";
		$content .= "background: url('".$pluginURL."/images/sns_icons_".$icon_size['width']."x".$icon_size['height'].".png') no-repeat;";
		$content .= "}";
			
		if($data[$position.'_sidename']) {			// 쪽그림 옆에 이름을 붙일 때

			$content .= "#sns_icons_".$position." span.sidename {";
			$content .= "display: inline-block;";
			$content .= "margin-top:".round(($icon_size['height']-$data[$position.'_sidename_font_size'])/2)."px;";
			$content .= "margin-left:".($data[$position.'_sidename_margin_left'])."px;";
			if($data[$position.'_sidename_margin_left']) $content .= "margin-right:".($data[$position.'_sidename_margin_left'])."px;";
			$content .= "font:".$data[$position.'_sidename_font_size']."px dotum;";
			$content .= "vertical-align:top;";
			$content .= "}";
		}
			
		SNS_names($sns_name_array, $sns_balloon_name_array, $sns_sidename_array);
		$i = 0;
		foreach($sns_name_array as $sns_name)
			$content .= "#sns_icons_".$position." div.icon_wrap .".$sns_name." {background-position:".(-($i++)*$icon_size['width'])."px 0;}";
	}
			
	return $content;
}

/* *** 위치에 맞게 단추의 HTML 태그를 돌려 준다. *** */
function show_icons($position) {
	
	global $pageTitle, $blog, $configVal, $entry;
	$data = Setting::fetchConfigVal($configVal);

	$context = Model_Context::getInstance();
	$defaultURL = $context->getProperty('uri.default');
	$blogid = $context->getProperty('blog.id');
	$useEncodeURL =  $context->getProperty('service.useEncodeURL');
	
	if(is_null($data)) init_config($data);			// 설정값이 없으면 기본값을 넣는다.
	
	if($entry['id']) $url = $defaultURL."/".($blog['useSloganOnPost'] && $data['blog_url']==1 ? "entry/".URL::encode($entry['slogan'], $useEncodeURL) : $entry['id']);		// 글 주소
	else $url = "http://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
	$encoded_url = urlencode($url);

	$title = $pageTitle ? $pageTitle : $blog['title'];
	$encoded_title = urlencode($title);

	$text = htmlspecialchars(UTF8::lessenAsEm((stripHTML($entry['content'])), 150));			// 본문의 앞 내용을 따온다.
	//$text = htmlspecialchars(UTF8::lessenAsEm(removeAllTags(stripHTML($entry['content'])), 150));		
	$encoded_text = urlencode($text);
	
	$tags_array = getTags($blogid, $entry['id']);		// 글의 꼬리표를 따온다.
	foreach($tags_array as $tag) $tags .= $tag['name'].",";
	if(substr($tags,-1) == ",") $tags = substr($tags,0,-1);
	$encoded_tags = urlencode($tags);

	switch($data['twitter_link']) {			// 선택값에 따라 트위터에 넣을 글 주소(고유주소/단축주소)를 정한다.
		case 1:		// 블로그 고유 주소 쓰기
			$twitter_link = "http://twitter.com/home/?status=".$encoded_title.urlencode(' ').$encoded_url;
			if($data['twitter_id']) $twitter_link .= " via @".$data['twitter_id'];
			break;
		case 2;		// 단축 주소(t.co) 쓰기
			if($entry['id']) $encoded_url_in_twitter = $defaultURL."/".$entry['id'];		// 블로그 숫자 주소로 연결함
			else $encoded_url_in_twitter = $encoded_url;
			$twitter_link = "http://twitter.com/intent/tweet?text=".$encoded_title;
			$twitter_link .= "&amp;url=".$encoded_url_in_twitter;
			if($data['twitter_id']) $twitter_link .= "&amp;via=".$data['twitter_id'];
			break;
	}
	
	$link['twitter'] = $twitter_link;
	$link['facebook'] = "http://www.facebook.com/sharer.php?u=".$encoded_url."&amp;t=".$encoded_title;
	$link['me2day'] = "http://me2day.net/posts/new?new_post[body]=".$encoded_title.urlencode(" \"").$encoded_url.urlencode("\":").$encoded_url."&amp;new_post[tags]=".$encoded_tags;
	$link['yozm'] = "http://yozm.daum.net/api/popup/prePost?sourceid=41&amp;link=".$encoded_url."&amp;prefix=".$encoded_title."+".$encoded_url;
	$link['c_empathy'] = "http://csp.cyworld.com/bi/bi_recommend_pop.php?url=".$url."&amp;t=".$encoded_title;
	$link['google'] = "https://www.google.com/bookmarks/mark?op=add&amp;bkmk=".$encoded_url."&amp;title=".$encoded_title."&amp;annotation=".$encoded_text."&amp;labels=".$encoded_tags;
	$link['digg'] = "http://digg.com/submit?phase=0&amp;url=".$encoded_url."&amp;title=".$encoded_title."&amp;bodytext=".$encoded_text;
	$link['delicious'] = "http://www.delicious.com/save?v=5&amp;noui&amp;jump=close&amp;url=".$encoded_url."&amp;title=".$encoded_title; //."&amp;tags=".$encoded_tags;

	$icon_type = $data[$position.'_type'] == "text" ? $icon_type = "button" : $icon_type = "div";
	
	if(strpos($_SERVER['HTTP_USER_AGENT'], "MSIE")) {
		preg_match("/MSIE (?P<version>\d+)/", $_SERVER['HTTP_USER_AGENT'], $browser);
		if($browser['version'] < 8) $icon_type = "button";
	}

	$content .= '<div id="sns_icons_'.$position.'">';

	SNS_names($sns_name_array, $sns_balloon_name_array, $sns_sidename_array);

	foreach($sns_name_array as $sns_name) {

		if($data[$position.'_'.$sns_name]) {
			$sns_balloon_name = $sns_balloon_name_array[$sns_name];
			$sns_sidename = $sns_sidename_array[$sns_name];
			$window_width = 750;
			$window_height = 510;
			if($sns_name == "me2day") $window_width = 980;
			$content .= '<div class="icon_wrap" title="'.$sns_balloon_name.'에 보내기" onclick="window.open(\''.$link[$sns_name].'\',\''.$sns_name.'\',\'width='.$window_width.',height='.$window_height.',resizable=1,scrollbars=1\');">';
			$content .= '<'.$icon_type.' class="'.$sns_name.'">';
			if($data[$position.'_type']=="text") $content .= "<span style='display:inline-block;'>".$sns_sidename."</span>";
			$content .= "</".$icon_type.">";
			if($data[$position.'_sidename'] && $data[$position.'_type']!="text") $content .= '<span class="sidename">'.$sns_sidename.'</span>';
			$content .= "</div>";
		}
	}

	$content .= "</div>".CRLF;
	
	return CRLF.$content;
}

/* ***	치환자 [##_SNS_icons_##]에 단추를 나타낸다. *** */
function show_tag($target) {

	global $configVal;
	$data = Setting::fetchConfigVal($configVal);

	if(is_null($data)) init_config($data);

	$position = "onTag";
	
	$tagContent = "<style type=\"text/css\">";
	$tagContent .= stylesheet($position);
	$tagContent .= "</style>";
	$tagContent .= show_icons($position);

	return $tagContent;
}

/* ***	옆막대에 단추를 나타낸다. *** */
function show_at_sidebar($parameter) {

	global $configVal;
	$data = Setting::fetchConfigVal($configVal);

	if(is_null($data)) init_config($data);

	$position = "onSidebar";
	
	$sidebarContent = "<style type=\"text/css\">";
	$sidebarContent .= stylesheet($position);
	$sidebarContent .= "</style>";
	$sidebarContent .= show_icons($position);

	return $sidebarContent;
}


/* ***	본문에 단추를 나타낸다. *** */
function show_at_content($target, $mother) {

	global $configVal;
	$data = Setting::fetchConfigVal($configVal);
	
	if(is_null($data)) init_config($data);

	$position_array = array("onTop", "onBottom");
	
	foreach($position_array as $position) 
		if($data[$position]) $content[$position] = show_icons($position);
	
	return $content['onTop'].$target.$content['onBottom'];
}

/* *** 환경 설정값이 들어 있지 않으면 기본값을 넣는다. *** */
function init_config(&$data) {
	
	$data['onTop'] = 0;
	$data['onBottom'] = 1;

	$position_array = array("onTop", "onBottom", "onSidebar", "onTag");
	SNS_names(&$sns_name_array, $sns_balloon_name_array, $sns_sidename_array);

	foreach($position_array as $position) {
		foreach($sns_name_array as $sns_name) $data[$position.'_'.$sns_name] = 1;
		$data[$position.'_type'] = "24x24";
		$data[$position.'_align'] = "right";
		$data[$position.'_icon_interval'] = "5";
		$data[$position.'_sidename'] = "0";
		$data[$position.'_sidename_font_size'] = "12";
		$data[$position.'_sidename_margin_left'] = "5";
		$data[$position.'_sidename_margin_right'] = "5";
		$data[$position.'_margin_top'] = "10";
		$data[$position.'_margin_bottom'] = "10";
		$data[$position.'_margin_left'] = "0";
		$data[$position.'_margin_right'] = "0";
	}

	$data['blog_url'] = 1;

	$data['twitter_link'] = 1;
	$data['twitter_id'] = "";
}


function SNS_icons_DataSet($data){

	return true;
}

/* *** SNS와 즐겨찾기 누리집의 이름을 넣는다. *** */
function SNS_names(&$sns_name_array, &$sns_balloon_name_array, &$sns_sidename_array){
	$sns_name_array = array("twitter", "facebook", "me2day", "yozm", "c_empathy", "google", "digg", "delicious");
	$sns_balloon_name_array = array('twitter'=>"트위터", 'facebook'=>"페이스북", 'me2day'=>"미투데이", 'yozm'=>"요즘", 'c_empathy'=>"C공감", 'google'=>"구글 즐겨찾기", 'digg'=>"디그", 'delicious'=>"딜리셔스");
	$sns_sidename_array = array('twitter'=>"트위터", 'facebook'=>"페이스북", 'me2day'=>"미투데이", 'yozm'=>"요즘", 'c_empathy'=>"C공감", 'google'=>"구글", 'digg'=>"디그", 'delicious'=>"딜리셔스");
}

function SNS_icons_config($plugin) {

	SNS_names($sns_name_array, $sns_balloon_name_array, $sns_sidename_array);
	
	$position_array = array("onTop", "onBottom", "onSidebar", "onTag");
	$position_name_array = array('onTop'=>"본문 위", 'onBottom'=>"본문 아래", 'onSidebar'=>"옆막대(사이드바)", 'onTag'=>"치환자");

	$manifest .= '<config dataValHandler = "SNS_icons_DataSet">'.CRLF;
	$manifest .= '	<window width="500" height="700" />'.CRLF;
	$manifest .= '	<fieldset legend="본문에 넣을 곳">'.CRLF;
	$manifest .= '		<field title=" " type="checkbox" name="positions">'.CRLF;
	$manifest .= '			<op name="onTop" value="1"><![CDATA[본문 위]]></op>'.CRLF;
  $manifest .= '			<op name="onBottom" value="1" checked="checked"><![CDATA[본문 아래]]></op>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '	</fieldset>'.CRLF;
	foreach($position_array as $position) {
		$position_name = $position_name_array[$position];
		$manifest .= '	<fieldset legend="'.$position_name.'">'.CRLF;
		$manifest .= '		<field title=" " type="checkbox" name="buttons">'.CRLF;
		foreach($sns_name_array as $sns_name) {
			$sns_sidename = $sns_sidename_array[$sns_name];
 			$manifest .= '			<op name="'.$position.'_'.$sns_name.'" value="1" checked="checked"><![CDATA['.$sns_sidename.']]></op>'.CRLF;
 		}
		$manifest .= '		</field>'.CRLF;
		$manifest .= '		<field title="단추 모양 :" name="'.$position.'_type" type="radio">'.CRLF;
		$manifest .= '			<op value="31x31"><![CDATA[31x31 쪽그림]]></op>'.CRLF;
    $manifest .= '		  <op value="24x24" checked="checked"><![CDATA[24x24 쪽그림]]></op>'.CRLF;
		$manifest .= '			<op value="text"><![CDATA[글 단추]]></op>'.CRLF;
		$manifest .= '		</field>'.CRLF;
		$manifest .= '		<field title="가로 정렬 :" name="'.$position.'_align" type="radio">'.CRLF;
		$manifest .= '			<op value="left"><![CDATA[왼쪽]]></op>'.CRLF;
    $manifest .= '	 		<op value="center"><![CDATA[가운데]]></op>'.CRLF;
		$manifest .= '			<op value="right" checked="checked"><![CDATA[오른쪽]]></op>'.CRLF;
		$manifest .= '			<op value=""><![CDATA[정렬하지 않음]]></op>'.CRLF;
		$manifest .= '		</field>'.CRLF;
		$manifest .= '		<field title="단추 간격 :" name="'.$position.'_icon_interval" type="text" size="4" value="5" titledirection="" />'.CRLF;
		$manifest .= '		<field title="쪽그림 옆에 이름 넣기" name="sidename" type="checkbox">'.CRLF;
		$manifest .= '			<op name="'.$position.'_sidename" value="1"></op>'.CRLF;
		$manifest .= '		</field>'.CRLF;
		$manifest .= '		<field title="쪽그림 옆 이름 글꼴 크기 :" name="'.$position.'_sidename_font_size" type="text" size="4" value="12" />'.CRLF;
		$manifest .= '		<field title="쪽그림 옆 이름 왼쪽 여백 :" name="'.$position.'_sidename_margin_left" type="text" size="4" value="5" />'.CRLF;
		$manifest .= '		<field title="쪽그림 옆 이름 오른쪽 여백 :" name="'.$position.'_sidename_margin_right" type="text" size="4" value="5" />'.CRLF;
		$manifest .= '		<field title=": 위쪽 여백" name="'.$position.'_margin_top" type="text" size="5" value="10" titledirection="bk" />'.CRLF;
		$manifest .= '		<field title=": 아래쪽 여백" name="'.$position.'_margin_bottom" type="text" size="5" value="10" titledirection="bk" />'.CRLF;
		$manifest .= '		<field title=": 왼쪽 여백" name="'.$position.'_margin_left" type="text" size="5" value="0" titledirection="bk" />'.CRLF;
		$manifest .= '		<field title=": 오른쪽 여백" name="'.$position.'_margin_right" type="text" size="5" value="0" titledirection="bk">'.CRLF;
		$manifest .= '			<caption><![CDATA[여백, 간격, 글꼴 크기에 단위(px, pt, mm, in, ...)를 넣지 않으면 px를 단위로 붙입니다.]]></caption>'.CRLF;
		$manifest .= '		</field>'.CRLF;

		$manifest .= '	</fieldset>'.CRLF;
	}
	$manifest .= '	<fieldset legend="글 고유 주소">'.CRLF;
	$manifest .= '		<field title=" " name="blog_url" type="radio">'.CRLF;
	$manifest .= '			<op value="1" checked="checked"><![CDATA[공개 주소 쓰기]]></op>'.CRLF;
	$manifest .= '			<op value="2"><![CDATA[숫자 주소 쓰기]]></op>'.CRLF;
	$manifest .= '			<caption><![CDATA[숫자 주소를 고르면 문자 주소(제목 주소)를 공개하더라도 숫자 주소를 넣습니다. 방명록, 글 분류, 보관함 등은 이 설정과 관계 없이 원래 주소를 넣습니다.]]></caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '	</fieldset>'.CRLF;
	$manifest .= '	<fieldset legend="트위터">'.CRLF;
	$manifest .= '		<field title="트위터 연결 주소 :" name="twitter_link" type="radio">'.CRLF;
	$manifest .= '			<op value="1" checked="checked"><![CDATA[블로그 고유 주소]]></op>'.CRLF;
	$manifest .= '			<op value="2"><![CDATA[짧은 주소(t.co)]]></op>'.CRLF;
	$manifest .= '			<caption><![CDATA[짧은 주소(t.co)를 쓰면 글 주소는 숫자 주소로 넣습니다.]]></caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		<field title="트위터 아이디" name="twitter_id" type="text" size="15" value="">'.CRLF;
	$manifest .= '			<caption><![CDATA[트위터 아이디를 넣으면 뒤쪽에 \'via @아이디\'를 붙입니다.]]></caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '	</fieldset>'.CRLF;
	$manifest .= '</config>'.CRLF;

	return $manifest;
}

?>